<template>
  <div class="row">
    <div class="col-lg-6 m-auto">
      <b-card :title="$t('login')">
        <form @submit.prevent="login" @keydown="form.onKeydown($event)">
          <!-- Name -->
          <div class="form-group row">
            <label class="col-md-12 col-form-label">{{ $t('name') }}</label>
            <div class="col-md-12">
              <input v-model="form.name" :class="{ 'is-invalid': form.errors.has('name') }" class="form-control" type="text" name="name">
              <has-error :form="form" field="name" />
            </div>
          </div>

          <!-- Password -->
          <div class="form-group row">
            <label class="col-md-12 col-form-label">{{ $t('password') }}</label>
            <div class="col-md-12">
              <input v-model="form.password" :class="{ 'is-invalid': form.errors.has('password') }" class="form-control" type="password" name="password">
              <has-error :form="form" field="password" />
            </div>
          </div>

          <!-- Remember Me -->
          <div class="form-group row">
            <div class="col-md-12" />
            <div class="col-md-12 d-flex">
              <checkbox v-model="remember" name="remember">
                {{ $t('remember_me') }}
              </checkbox>
            </div>
          </div>

          <div class="form-group row">
            <div class="col-md-12 d-flex">
              <!-- Submit Button -->
              <v-button :loading="form.busy" block>
                {{ $t('login') }}
              </v-button>
            </div>
          </div>
        </form>
      </b-card>
    </div>
  </div>
</template>

<script>
import Form from 'vform'

export default {
  middleware: 'guest',

  metaInfo () {
    return { title: this.$t('login') }
  },

  data: () => ({
    form: new Form({
      name: '',
      password: ''
    }),
    remember: false
  }),

  methods: {
    async login () {
      // Submit the form.
      const { data } = await this.form.post(route('shop.auth.login'))

      // Save the token.
      this.$store.dispatch('auth/saveToken', {
        token: data.token,
        remember: this.remember
      })

      // Fetch the user.
      await this.$store.dispatch('auth/fetchUser')

      // Redirect home.
      this.$router.push({ name: 'home' })
    }
  }
}
</script>
